/*
 * adopted from reference examples of textbook
 */
#include <GL/glut.h>
#include <fstream>

void drawPolyLineFile(const char * fileName) {
	std::ifstream inStream;
	inStream.open(fileName);	         // open the file
	if (inStream.fail()) return;
	GLint numpolys, numLines, x, y;
	inStream >> numpolys;		        // read the number of polylines
	for (int j = 0; j < numpolys; j++)  // for each polyline
	{
		inStream >> numLines;           // get the number of line segments
		glBegin(GL_LINE_STRIP);	        // draw the polyline
		for (int i = 0; i < numLines; i++) {
			inStream >> x >> y;        // read the next x, y pair
			glVertex2i(x, y);
		}
		glEnd();
	}
	glFlush();
	inStream.close();
}

//--------------- setWindow ---------------------
void setWindow(float left, float right, int bottom, int top) {
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(left, right, bottom, top);
}

//---------------- setViewport ------------------
void setViewport(int left, int bottom, int width, int height) {
	glViewport(left, bottom, width, height);
}

// draw one dinosaur
void render() {
	glClear(GL_COLOR_BUFFER_BIT);
	setWindow(0, 640.0, 0, 480.0);
	drawPolyLineFile("dino.dat");
	glFlush();
}

//// draw array of dinosaurs
//void render() {
//	glClear(GL_COLOR_BUFFER_BIT);
//	setWindow(0, 640.0, 0, 480.0);		// set a fixed window
//	for (int i = 0; i < 5; i++) {	    // for each column
//		for (int j = 0; j < 5; j++)		// for each row
//		{
//			glViewport(i * 64, j * 44, 64, 44); // set the next viewport
//			drawPolyLineFile("dino.dat");		// draw it again
//		}
//	}
//	glFlush();
//}

//// draw array of dinosaurs with up/down direction views
//void render() {
//	glClear(GL_COLOR_BUFFER_BIT);
//	for (int i = 0; i < 5; i++)
//		for (int j = 0; j < 5; j++) {
//			if ((i + j) % 2 == 1)            	   // if (i + j) is odd
//				setWindow(0.0, 640.0, 0.0, 480.0); // right side up window
//			else
//				setWindow(0.0, 640.0, 480.0, 0.0); // upside down window
//			glViewport(i * 64, j * 44, 64, 44);    // set the next viewport
//			drawPolyLineFile("dino.dat");		   // draw it again setWindow .
//		}
//	glFlush();
//}

int main(int argc, char** argv) {
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
	glutInitWindowSize(640, 480);
	glutInitWindowPosition(0, 0);
	glutCreateWindow("Poly Line Demo");
	glutDisplayFunc(render);
	glutMainLoop();
	return 0;
}
